frmCalendar.onshow = function() {
  hmbrNav.style.display = 'block';
}

mobiscroll.setOptions({
  theme: 'ios',
  themeletiant: 'light'
});

let query1
let query2
let query3
let titleApp
let descriptionApp
let allDayApp
let startApp
let endApp

let oldEvent;
let tempEvent = {};
let deleteEvent;
let restoreEvent;
let colorPicker;
let tempColor;
let titleInput = document.getElementById('event-title');
let descriptionTextarea = document.getElementById('event-desc');
let allDaySwitch = document.getElementById('event-all-day');
let freeSegmented = document.getElementById('event-status-free');
let busySegmented = document.getElementById('event-status-busy');
let deleteButton = document.getElementById('event-delete');
let colorSelect = document.getElementById('event-color-picker');
let pickedColor = document.getElementById('event-color');
let colorElms = document.querySelectorAll('.crud-color-c');
let datePickerResponsive = {
  medium: {
    controls: ['calendar'],
    touchUi: false,
  },
};
let datetimePickerResponsive = {
  medium: {
    controls: ['calendar', 'time'],
    touchUi: false,
  },
};
let myData = [
  {
    id: 1,
    start: '2024-03-08T13:00',
    end: '2024-03-08T13:45',
    title: "Study Session",
    description: 'Harper Center: 602 N 20th St, Omaha, NE 68102',
    allDay: false,
    free: true,
    color: '#009788',
  },
  {
    id: 2,
    start: '2024-03-27T15:00',
    end: '2024-03-27T16:00',
    title: 'Babysitting',
    description: 'Henry Doorly Zoo: 3701 S 10th St, Omaha, NE 68107',
    allDay: false,
    free: false,
    color: '#ff9900',
  },
  {
    id: 3,
    start: '2024-03-26T18:00',
    end: '2024-03-26T22:00',
    title: 'Birthday Party',
    description: "Larson's House: 4157 Cuming St, Omaha, NE 68131",
    allDay: false,
    free: true,
    color: '#3f51b5',
  }
];

function createAddPopup(elm) {
  // hide delete button inside add popup
  deleteButton.style.display = 'none';

  deleteEvent = true;
  restoreEvent = false;

  // set popup header text and buttons for adding
  popup.setOptions({
    headerText: 'New event',
    buttons: [
      'cancel',
      {
        text: 'Add',
        keyCode: 'enter',
        handler: function () {
          calendar.updateEvent({
            id: tempEvent.id,
            title: tempEvent.title,
            description: tempEvent.description,
            allDay: tempEvent.allDay,
            start: tempEvent.start,
            end: tempEvent.end,
            color: tempEvent.color,
          });
          
          query1 = "INSERT INTO calendar (id, title, description, allDay, start, end) VALUES ('" + tempEvent.id + "', '" + tempEvent.title + "', '" + tempEvent.description + "', '" + tempEvent.allDay + "', '" + tempEvent.start + "', '" + tempEvent.end + "')";
          alert(query1)
          req = Ajax(
               "https://ormond.creighton.edu/courses/375/ajax-connection.php",
               "POST",
               "host=ormond.creighton.edu&user=" +
                    netID +
                    "&pass=" +
                    pass +
                    "&database=" +
                    grpID +
                    "&query=" +
                    query1
          );
          // navigate the calendar to the correct view
          calendar.navigateToEvent(tempEvent);
          deleteEvent = false;
          popup.close();
        },
        cssClass: 'mbsc-popup-button-primary',
      },
    ],
  });

  // fill popup with a new event data
  mobiscroll.getInst(titleInput).value = tempEvent.title;
  mobiscroll.getInst(descriptionTextarea).value = '';
  mobiscroll.getInst(allDaySwitch).checked = true;
  range.setVal([tempEvent.start, tempEvent.end]);
  mobiscroll.getInst(busySegmented).checked = true;
  range.setOptions({ controls: ['date'], responsive: datePickerResponsive });
  pickedColor.style.background = '';

  // set anchor for the popup
  popup.setOptions({ anchor: elm });

  popup.open();
}

function createEditPopup(args) {
  let ev = args.event;

  // show delete button inside edit popup
  deleteButton.style.display = 'block';

  deleteEvent = false;
  restoreEvent = true;

  // set popup header text and buttons for editing
  popup.setOptions({
    headerText: 'Edit event',
    buttons: [
      'cancel',
      {
        text: 'Save',
        keyCode: 'enter',
        handler: function () {
          let date = range.getVal();
          let eventToSave = {
            id: ev.id,
            title: titleInput.value,
            description: descriptionTextarea.value,
            allDay: mobiscroll.getInst(allDaySwitch).checked,
            start: date[0],
            end: date[1],
            free: mobiscroll.getInst(freeSegmented).checked,
            color: ev.color,
          };
          
          titleApp = titleInput.value
          descriptionApp = descriptionTextarea.value
          allDayApp = mobiscroll.getInst(allDaySwitch).checked
          startApp = date[0]
          endApp = date[1]
          
          query2 = "UPDATE calendar SET title = '" + titleApp + "', description = '" + descriptionApp + "', allDay = '" + allDayApp + "', start = '" + startApp + "', end = '" + endApp + "' WHERE id = '" + ev.id + "'"
          alert(query2)
          req = Ajax(
               "https://ormond.creighton.edu/courses/375/ajax-connection.php",
               "POST",
               "host=ormond.creighton.edu&user=" +
                    netID +
                    "&pass=" +
                    pass +
                    "&database=" +
                    grpID +
                    "&query=" +
                    query2)
          
          // update event with the new properties on save button click
          calendar.updateEvent(eventToSave);
          // navigate the calendar to the correct view
          calendar.navigateToEvent(eventToSave);
          restoreEvent = false;
          popup.close();
        },
        cssClass: 'mbsc-popup-button-primary',
      },
    ],
  });

  // fill popup with the selected event data
  mobiscroll.getInst(titleInput).value = ev.title || '';
  mobiscroll.getInst(descriptionTextarea).value = ev.description || '';
  mobiscroll.getInst(allDaySwitch).checked = ev.allDay || false;
  range.setVal([ev.start, ev.end]);
  pickedColor.style.background = ev.color || '';

  if (ev.free) {
    mobiscroll.getInst(freeSegmented).checked = true;
  } else {
    mobiscroll.getInst(busySegmented).checked = true;
  }

  // change range settings based on the allDay
  range.setOptions({
    controls: ev.allDay ? ['date'] : ['datetime'],
    responsive: ev.allDay ? datePickerResponsive : datetimePickerResponsive,
  });

  // set anchor for the popup
  popup.setOptions({ anchor: args.domEvent.currentTarget });
  popup.open();
}

let calendar = mobiscroll.eventcalendar('#demo-add-delete-event', {
  clickToCreate: 'double',
  dragToCreate: true,
  dragToMove: true,
  dragToResize: true,
  view: {
    calendar: { labels: true },
  },
  data: myData,
  onEventClick: function (args) {
    oldEvent = Object.assign({}, args.event);
    tempEvent = args.event;

    if (!popup.isVisible()) {
      createEditPopup(args);
    }
  },
  onEventCreated: function (args) {
    popup.close();
    // store temporary event
    tempEvent = args.event;
    createAddPopup(args.target);
  },
  onEventDeleted: function (args) {
    mobiscroll.snackbar({
      button: {
        action: function () {
          calendar.addEvent(args.event);
        },
        text: 'Undo',
      },
      message: 'Event deleted',
    });
  },
});

let popup = mobiscroll.popup('#demo-add-popup', {
  display: 'bottom',
  contentPadding: false,
  fullScreen: true,
  onClose: function () {
    if (deleteEvent) {
      calendar.removeEvent(tempEvent);
    } else if (restoreEvent) {
      calendar.updateEvent(oldEvent);
    }
  },
  responsive: {
    medium: {
      display: 'anchored',
      width: 400,
      fullScreen: false,
      touchUi: false,
    },
  },
});

titleInput.addEventListener('input', function (ev) {
  // update current event's title
  tempEvent.title = ev.target.value;
});

descriptionTextarea.addEventListener('change', function (ev) {
  // update current event's title
  tempEvent.description = ev.target.value;
});

allDaySwitch.addEventListener('change', function () {
  let checked = this.checked;
  // change range settings based on the allDay
  range.setOptions({
    controls: checked ? ['date'] : ['datetime'],
    responsive: checked ? datePickerResponsive : datetimePickerResponsive,
  });

  // update current event's allDay property
  tempEvent.allDay = checked;
});

let range = mobiscroll.datepicker('#event-date', {
  controls: ['date'],
  select: 'range',
  startInput: '#start-input',
  endInput: '#end-input',
  showRangeLabels: false,
  touchUi: true,
  responsive: datePickerResponsive,
  onChange: function (args) {
    let date = args.value;
    // update event's start date
    tempEvent.start = date[0];
    tempEvent.end = date[1];
  },
});

document.querySelectorAll('input[name=event-status]').forEach(function (elm) {
  elm.addEventListener('change', function () {
    // update current event's free property
    tempEvent.free = mobiscroll.getInst(freeSegmented).checked;
  });
});

deleteButton.addEventListener('click', function () {
  // delete current event on button click
  calendar.removeEvent(tempEvent);

  // save a local reference to the deleted event
  let deletedEvent = tempEvent;
  popup.close();

  mobiscroll.snackbar({
    button: {
      action: function () {
        calendar.addEvent(deletedEvent);
      },
      text: 'Undo',
    },
    message: 'Event deleted',
  });
          query3 = "DELETE FROM calendar WHERE id = '" +deletedEvent.id + "'"
          alert(query3)
            req = Ajax(
               "https://ormond.creighton.edu/courses/375/ajax-connection.php",
               "POST",
               "host=ormond.creighton.edu&user=" +
                    netID +
                    "&pass=" +
                    pass +
                    "&database=" +
                    grpID +
                    "&query=" +
                    query3)
});

colorPicker = mobiscroll.popup('#demo-event-color', {
  display: 'bottom',
  contentPadding: false,
  showArrow: false,
  showOverlay: false,
  buttons: [
    'cancel',
    {
      text: 'Set',
      keyCode: 'enter',
      handler: function () {
        setSelectedColor();
      },
      cssClass: 'mbsc-popup-button-primary',
    },
  ],
  responsive: {
    medium: {
      display: 'anchored',
      anchor: document.getElementById('event-color-cont'),
      buttons: {},
    },
  },
});

function selectColor(color, setColor) {
  let selectedElm = document.querySelector('.crud-color-c.selected');
  let newSelected = document.querySelector('.crud-color-c[data-value="' + color + '"]');

  if (selectedElm) {
    selectedElm.classList.remove('selected');
  }
  if (newSelected) {
    newSelected.classList.add('selected');
  }
  if (setColor) {
    pickedColor.style.background = color || '';
  }
}

function setSelectedColor() {
  tempEvent.color = tempColor;
  pickedColor.style.background = tempColor;
  colorPicker.close();
}

colorSelect.addEventListener('click', function () {
  selectColor(tempEvent.color || '');
  colorPicker.open();
});

colorElms.forEach(function (elm) {
  elm.addEventListener('click', function () {
    tempColor = elm.getAttribute('data-value');
    selectColor(tempColor);

    if (!colorPicker.s.buttons.length) {
      setSelectedColor();
    }
  });
});

